//+------------------------------------------------------------------+
//|                                               ExFit Color_v2.mq4 |
//|                                Copyright  2014, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   3
#property indicator_color1    OrangeRed
#property indicator_width1    2
#property indicator_color2    DeepSkyBlue
#property indicator_width2    2
#property indicator_color3    DeepSkyBlue
#property indicator_width3    2
#property indicator_maximum 100
#property indicator_minimum   0


extern int     Length         =  25;   //Period of Smoothing
extern int     Order          =   2;   //Fitting Order
extern double  WeightFactor   =   2;   //WeightFactor(eg. 2-EMA,1-Wilder) 
extern double  OverSold       =  30;   //OverSold Level
extern double  OverBought     =  70;   //OverBought Level
extern int     Window         = 500;   //Window size in bars


double stoch[];
double uptrend1[];
double uptrend2[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
{
   IndicatorDigits(Digits);
   
   IndicatorBuffers(4);
   SetIndexBuffer(0,   stoch); SetIndexStyle(0,DRAW_LINE); 
   SetIndexBuffer(1,uptrend1); SetIndexStyle(1,DRAW_LINE); 
   SetIndexBuffer(2,uptrend2); SetIndexStyle(2,DRAW_LINE); 
   SetIndexBuffer(3,   trend);
     
   IndicatorShortName("ExFit Stoch_v2("+Length+","+Order+")");
   
      
   SetIndexLabel(0,"Stoch"  );
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"UpTrend");
     
   return (0);
}
//+------------------------------------------------------------------+
//| ExFit Stoch_v2                                                   |
//+------------------------------------------------------------------+
int start() 
{
   int shift, counted_bars = IndicatorCounted();
      
   if(counted_bars < 0) return(0);
  	if(counted_bars < 1)
  	{  
      for(int i=0;i<Bars-1;i++) 
      {
      stoch[i]    = EMPTY_VALUE;
      uptrend1[i] = EMPTY_VALUE; 
      uptrend2[i] = EMPTY_VALUE;
      }
   
   SetLevelValue(0,50);
   if(OverSold   != 50) SetLevelValue(1,OverSold);
   if(OverBought != 50) SetLevelValue(2,OverBought);
   
   SetLevelStyle(2,1,Silver);
   }
   
   xfit(Length,Order,WeightFactor,Window,counted_bars,stoch);
   
   for(shift=Window-1;shift>=0;shift--)
   {
   uptrend1[shift] = EMPTY_VALUE; 
   uptrend2[shift] = EMPTY_VALUE;
                 
   trend[shift] = trend[shift+1];
   if(stoch[shift] > stoch[shift+1]) trend[shift] = 1;
   if(stoch[shift] < stoch[shift+1]) trend[shift] =-1;    
         
      if(trend[shift] > 0)
      {
         if(uptrend1[shift+1] == EMPTY_VALUE)
         {
            if(uptrend1[shift+2] == EMPTY_VALUE) 
            {
            uptrend1[shift]   = stoch[shift];
            uptrend1[shift+1] = stoch[shift+1];
            uptrend2[shift]   = EMPTY_VALUE;
            }
            else 
            {
            uptrend2[shift]   = stoch[shift];
            uptrend2[shift+1] = stoch[shift+1];
            uptrend1[shift]   = EMPTY_VALUE;
            }
         }
         else
         {
         uptrend1[shift]  = stoch[shift];
         uptrend2[shift]  = EMPTY_VALUE;
         }
      }
   }   
     
   return (0);
}
   



//------
double value[];    
   
void xfit(int length,int order,double wf,int cntbars,int indcnt,double& xfit[])
{     
double iprice, value1, value2, alpha = wf/(length*0.5 + 1);    
   
   if(indcnt == 0) ArrayResize(value,cntbars); 
   
   for(int k=0;k<order;k++) 
   {
      for(int i=0;i<cntbars;i++) 
      {
      if(k == 0) iprice = iStochastic(NULL,0,length,1,1,MODE_SMA,0,MODE_MAIN,i); else iprice = xfit[i];
      if(i == 0) value1 = iprice;
         
      value[i] = alpha*iprice + (1 - alpha)*value1; 
      value1   = value[i];
      }
   
      for(i=cntbars-1;i>=0;i--) 
      {
      if(i == cntbars - 1) xfit[i] = value[i]; else xfit[i] = alpha*value[i] + (1 - alpha)*value2;
   
      value2 = xfit[i];
      }
   }
}   
   